/*
 * tracker.h
 * Copyright (C) 2005 Robin KAY. All rights reserved.
 *
 * The contents of this file are subject to the terms of the
 * Common Development and Distribution License, Version 1.0 only
 * (the "License").  You may not use this file except in compliance
 * with the License.
 */

#ifndef TRACKER_H
#define TRACKER_H

typedef int (*tracker_failed_cb_t)(int, const char *, void *);

extern void tracker_init();
extern int tracker_open_fd(int, const char *);
extern int tracker_dup_fd(int, int);
extern int tracker_close_fd(int);
extern int tracker_rewrite(int, const char *, path_rewrite_cb_t, tracker_failed_cb_t, void *);
extern int tracker_chdir(const char *);
extern int tracker_fchdir(int);
extern char *tracker_getcwd(char *, size_t);
extern int tracker_getdents(int, void *, size_t);
extern int tracker_getdents64(int, void *, size_t);

#endif
