/*
 * utils.h
 * Copyright (C) 2005 Robin KAY. All rights reserved.
 *
 * The contents of this file are subject to the terms of the
 * Common Development and Distribution License, Version 1.0 only
 * (the "License").  You may not use this file except in compliance
 * with the License.
 */

#ifndef UTILS_H
#define UTILS_H

typedef struct {
  char *buf;
  int len;
} path_buf_t;

typedef int (*path_rewrite_cb_t)(const char *, const char *, void *);

struct tree_node_s {
  struct tree_node_s *left;
  struct tree_node_s *right;
  struct tree_node_s *next;
};
typedef struct tree_node_s tree_node_t;

typedef int (*tree_cmp_cb_t)(void *, void *);

extern path_buf_t *path_clear(path_buf_t *);
extern path_buf_t *path_terminate(path_buf_t *);
extern path_buf_t *path_append(path_buf_t *, const char *, int);
extern path_buf_t *path_absolute(path_buf_t *, const char *);
extern int path_rewrite(const char *, path_rewrite_cb_t, void *);

extern void tree_insert(tree_node_t **, tree_cmp_cb_t, void *, size_t);
extern void tree_cleanup(tree_node_t **);
extern tree_node_t *tree_linearize(tree_node_t *);

#endif
